﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	
	Public m_lblHeader As Label
	Public m_pnlParent As Panel
	
	Public m_colorDateBoxBG As Int : m_colorDateBoxBG = Colors.DarkGray
	Public m_colorDateBoxFG As Int : m_colorDateBoxFG = Colors.White
	
	Public m_colorHeaderBG As Int : m_colorHeaderBG = Colors.Gray
	Public m_colorHeaderFG As Int : m_colorHeaderFG = Colors.white
	
	Public m_nLastDayInArr As Int
	Public m_FirstDayInArr As Int
	
	Public m_SelectedColor As Long : m_SelectedColor = Colors.Blue
	
	Public m_dtStartDate As Long
	Public m_dtCurrDate As Long
	Public m_dtOldDate As Long
	
	Private  m_sError As String
	'Private T1,T2 As Thread
	
	Private constDayTxt, constDayExtraTxt, constDayImg1,constDayImg2 As Int
	constDayTxt = 2 : constDayExtraTxt = 0 : constDayImg1 = 1 : constDayImg2 = 3
	
	Public m_nLasDayPressed As Int
	
	
	
End Sub


#Region Gets and Sets

'Returns the last error message
'(If something does not work the way you think then check this var)
Public Sub GetError As String
	Return m_sError
End Sub

'Returns the selected date as a string
Public Sub GetSelectedDay As String
End Sub

'Returns the selected date as a long (b4a date)
Public Sub GetSelectedDay2 As Long
End Sub

'Sets the extra text (the bottom label on the day panel)
's - text to place on cal day
'nDay - day to place text on
Public Sub	SetDayExtraTextOnCal(s As String, nDay As Int)
	Dim T As Panel : T.Initialize("")
	Dim l As Label : l.Initialize("")
	Dim pnlDayView As Panel : pnlDayView.Initialize("")
		
	T = m_pnlParent.GetView(nDay + m_FirstDayInArr - 1)
	pnlDayView = T.GetView(0)
	
	l = pnlDayView.GetView(constDayExtraTxt)
	l.Text = s
	l.Visible = True
End Sub

#End Region

#Region methods


'Changes the background color of a single day
'lNewColor - The new b4a color to use
'nDay - the day of the month you want to change the color for
Public Sub ChangeColor1Date( lNewColor As Long , nDay As Int)
	Dim T As Panel : T.Initialize("")
	Dim l As Label : l.Initialize("")
	Dim pnlDayView As Panel : pnlDayView.Initialize("")
		
	T = m_pnlParent.GetView(nDay + m_FirstDayInArr - 1)
	pnlDayView = T.GetView(0)
	pnlDayView.Color = lNewColor
	
End Sub

'set the nDay as the new selected day
'nDay - the day of the month you want selected
Public Sub SetSellectedCalDay(nDay As Int)
	UnSelectCalAll	
	ChangeColor1Date(m_SelectedColor,nDay)
	
End Sub

'Resets all days to NOT selected
Public Sub UnSelectCalAll
	Dim x As Int
	For x = m_FirstDayInArr To m_nLastDayInArr
		Dim T As Panel : T.Initialize("")
		Dim pnlDayView As Panel : pnlDayView.Initialize("")
			
		T = m_pnlParent.GetView(x )
		pnlDayView = T.GetView(0)
		pnlDayView.Color = m_colorDateBoxBG	
		
	Next
End Sub

'Clears the calendar completely of everything
Public Sub ClearCalAll()
 	Dim x As Int

	'--- 0 is the lblHeader
	For x = 1 To 42
		Dim T As Panel : T.Initialize("")
		Dim l As Label : l.Initialize("")
		Dim i As ImageView : l.Initialize("")
		Dim TT As Panel : TT.Initialize("")
		
		T = m_pnlParent.GetView(x)
		TT = T.GetView(0)
		
		i = TT.GetView(constDayImg1)     : i.Visible = False
		i = TT.GetView(constDayImg2)     : i.Visible = False
		l = TT.GetView(constDayTxt)      : l.Text = ""
		l = TT.GetView(constDayExtraTxt) : l.Text = ""
     Next
	 
 
End Sub

'Use this when you want to change the date
Public Sub  RefreshCalNewDate(dtNewDate As Long)
	
	m_dtOldDate = m_dtCurrDate
	m_dtCurrDate = DayDateOfMonth(dtNewDate,CStr(1))
	AdjustPanelMatrixDrawDays(m_dtCurrDate)
	SetSellectedCalDay(DateTime.GetDayOfMonth(m_dtCurrDate))
	
End Sub

'Clears the calendar but keeps the day text
Public Sub ClearCalKeepDays()
	'--- 0 is the lblHeader
 	Dim x As Int
	For x = 1 To 42

		Dim T As Panel : T.Initialize("")
		Dim l As Label : l.Initialize("")
		Dim i As ImageView : l.Initialize("")
		Dim pnlDayView As Panel : pnlDayView.Initialize("")
		
		T = m_pnlParent.GetView(x)
		pnlDayView = T.GetView(0)
		
		i = pnlDayView.GetView(constDayImg2)     : i.Visible = False
		i = pnlDayView.GetView(constDayImg1)    : i.Visible = False
		l = pnlDayView.GetView(constDayExtraTxt) : l.Text = ""
     Next
 
End Sub


'Places Day text on calendar
'arrayNumber - the master 42 panel number
'sDayNum - a string of the day you want to display
Public Sub SetDayTextOnPnl(arrayNumber As Int, sDayNum As String)
	Dim T As Panel : T.Initialize("")
	Dim l As Label : l.Initialize("")
	Dim pnlDayView As Panel : pnlDayView.Initialize("")
		
	T = m_pnlParent.GetView(arrayNumber)
	pnlDayView = T.GetView(0)
	
	l = pnlDayView.GetView(constDayTxt)
	l.Text = sDayNum
End Sub

'Hides a day panel 
'arrayNumber - the master 42 panel number
Public Sub HideDayPanel(arrayNumber As Int)

	Dim T As Panel : T.Initialize("")
	Dim pnlDayView As Panel : pnlDayView.Initialize("")
	
	T = m_pnlParent.GetView(arrayNumber)
	pnlDayView = T.GetView(0)
	pnlDayView.Visible = False
	

End Sub
'Hides a day panel 
'arrayNumber - the master 42 panel number
Public Sub UnHideDayPanel(arrayNumber As Int)

	Dim T As Panel : T.Initialize("")
	Dim pnlDayView As Panel : pnlDayView.Initialize("")
	
	T = m_pnlParent.GetView(arrayNumber)
	pnlDayView = T.GetView(0)
	pnlDayView.Visible = True
	

End Sub

'Returns the week day text for a given day (0 - 6)
'nDay - day of week you want text returned
Public Sub GetDayStr(nDay As Int) As String
	Dim WeekDaysStr() As String
	WeekDaysStr = Array As String ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday")
	Return WeekDaysStr(DateTime.GetDayOfWeek(DateTime.Now) + 1)
End Sub


#End Region


'--- Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pnl As Panel, dtStartDate As Long) 
	Dim delta,rate,scale
	delta = ((100%x + 100%y) / (800dip + 480dip) - 1)
	rate = 0.2
	scale = 1 + rate * delta

'	Dim lv As LayoutValues
'	lv = GetDeviceLayoutValues
'	scale = lv.Scale

	'T1.Initialise("T1")
	
	If pnl  = Null AND dtStartDate = Null Then
		'--- do not init anything, user is only using date and misc functions
		m_sError = "(fn) Function mode...  OK"
	Else
		If IsValidDate(Date2Str(dtStartDate)) Then
			m_dtStartDate = dtStartDate
			m_dtCurrDate = dtStartDate
			m_pnlParent = pnl
			'T1.RunOnGuiThread("InitCal",Null)
			'InitCal '--- lets do it!
		Else
			m_sError = "Date is not valid b4a LONG"
		End If
	End If
	Return Null
	
End Sub

'inits cal and sets defualts (You have to call Initialize first)
Public Sub InitCal

	DrawHeader

	'--- lets build the cal
	Log("start:" & DateTime.Time(DateTime.Now))
	Dim x,y As Int
	Dim top As Int : top = 24
	Dim width As Int: width = 64
	Dim height As Int: height = 48
	For y = 1 To 6		
		
		'--- loads days for the left side of the screen
		Dim pnlDay As Panel : pnlDay.Initialize("DayClick")
		pnlDay.LoadLayout("day")
		Dim T As Panel
		T = pnlDay.GetView(0)
		pnlDay.Color = m_colorDateBoxBG
		
		m_pnlParent.AddView(pnlDay,4 ,top,  width,height+1)
		
		For x = 1 To 6
		
			'--- loads all other week days
			Dim pnlDay As Panel  : 	pnlDay.Initialize("DayClick") 
		
			DoEvents
			
			pnlDay.LoadLayout("day")
			Dim T As Panel
			T = pnlDay.GetView(0)
			T.Color = m_colorDateBoxBG
			
			m_pnlParent.AddView(pnlDay,iif(x=1, x * 72, x * 70) ,top,width,height+1)
			
		Next
		top = iif(y=1, top + ( height)+2 , top + (height+2))
	Next
	Log("end " & DateTime.Time(DateTime.Now))

	AdjustPanelMatrixDrawDays(m_dtCurrDate)
	SetSellectedCalDay(DateTime.GetDayOfMonth(m_dtCurrDate))
	

End Sub



#Region Internal functions - methods


Private Sub DrawHeader
	'--- needs to be re-written
	m_lblHeader.Initialize("")
	m_lblHeader.TextSize = 12
	m_lblHeader.Color = m_colorHeaderBG
    m_lblHeader.TextColor = m_colorHeaderFG
	m_lblHeader.Text = "  Sun       Mon      Tue        Wed      Thur       Fri         Sat"
	m_pnlParent.AddView(m_lblHeader,4,2,m_pnlParent.Width - 4,20)
	
End Sub


Private Sub AdjustPanelMatrixDrawDays(dt1 As Long)
	

	
	'=== Fill the array with the propper data for the
	Dim offset As Int
	Dim nCurrentDayOfWeek      As Int
	Dim nWeekStart                  As Int
	Dim nCurrentWeek               As Int
	Dim nLastDayOfMonth         As Int
	Dim nCurrentDay                 As Int
	Dim dtFirstDayOfMonth       As Long
	
	dtFirstDayOfMonth = FDateOfMonth(dt1)
	Dim dayofweek As Int : 	dayofweek =  DateTime.GetDayOfWeek(dtFirstDayOfMonth)
	
     nLastDayOfMonth = GetLastDay(dt1)
     nCurrentWeek = 1
     nCurrentDay = 1
	
	ClearCalAll
	

	Dim dt As AHDateTime : 	dt.Initialize : dt.Pattern = "W"
	Dim nWeekInMonth As Int :   nWeekInMonth =  GetWeekNumberInMonth(dtFirstDayOfMonth)             'dt.format(dtFirstDayOfMonth)    '---week in month
	
	'Dim nWeekStart As Int :' nWeekStart = dt.format(dtFirstDayOfMonth)    
	
 	
	 Dim nMasterPnlArrayID As Int : nMasterPnlArrayID = 1
	 nWeekStart = 0
     For nCurrentWeek = 1 To 6
         If nCurrentWeek = 1 Then        'Start in the Right Place
			 If nWeekInMonth >=2 Then '--- NOT Working
			 	Dim xx As Int : For xx = 1 To 7 : HideDayPanel(xx)  : 	Next '--- hide all 1st week panels 
				offset = 7
				nWeekStart = 1
			 End If
         End If
 
		m_FirstDayInArr = dayofweek + offset
		m_nLastDayInArr = dayofweek + nLastDayOfMonth - 1 + offset
		 
		 
		 For nCurrentDayOfWeek = nWeekStart To 6
		 	If (nMasterPnlArrayID < m_FirstDayInArr) OR (nMasterPnlArrayID > m_nLastDayInArr) Then
				HideDayPanel(nMasterPnlArrayID)
			Else
				SetDayTextOnPnl(nMasterPnlArrayID, nMasterPnlArrayID - m_FirstDayInArr + 1)
				UnHideDayPanel(nMasterPnlArrayID)
			End If
			nMasterPnlArrayID = nMasterPnlArrayID + 1
 		Next
		
     Next

End Sub




Public Sub Process_KeyPress(KeyCode As Int) As Boolean 

'	If KeyCode = KeyCodes.KEYCODE_BACK Then Return True
'	If KeyCode = KeyCodes.KEYCODE_TAB Then Return True
'	If KeyCode = KeyCodes.KEYCODE_DPAD_DOWN Then Return True
'	If KeyCode = KeyCodes.KEYCODE_DPAD_LEFT Then Return True
'	If KeyCode = KeyCodes.KEYCODE_DPAD_RIGHT Then Return True
'	If KeyCode = KeyCodes.KEYCODE_DPAD_UP Then Return True
'	If KeyCode = KeyCodes.KEYCODE_HOME Then Return True
'	If KeyCode = KeyCodes.KEYCODE_SOFT_LEFT Then Return True
'	If KeyCode = KeyCodes.KEYCODE_SOFT_RIGHT Then Return True

	
End Sub






Private Sub DayClick_Click

	Dim o As Object, pnl As Panel
	o = Sender
	
	If o Is Panel Then
		Dim oo As Panel : oo.Initialize("") :  
		oo = o
		
		Dim T As Panel : T.Initialize("")
		Dim l As Label : l.Initialize("")
		
		
		T  = oo.GetView(0)
		
		'Log(pnlDayView.GetView(constDayTxt))
		l = T.GetView(constDayTxt)
		Dim nOldLastDay As Int :  nOldLastDay =  m_nLasDayPressed
		If l.Text = "" Then '--- invalid date
			Return
		End If
		m_nLasDayPressed = Str2Int(l.Text)

		SetSellectedCalDay(m_nLasDayPressed)
		
		'--- raise an event to the activity
		CallSub3("main","DatePressed",m_nLasDayPressed,DayDateOfMonth(m_dtStartDate,m_nLasDayPressed))
		
	Else 
		Log("AAAHHH Crap...   -->  uknown    'DayClick_Click'    event ")
		
	End If
	
	

End Sub

#End Region



#Region  Date functions

'Return the week number of the passed in b4a date
Public Sub GetWeekNumber4Year(ticks As Long) As Int
	Dim dt As AHDateTime
	dt.Initialize : dt.Pattern = "w"
	Return dt.format(ticks)    
End Sub

Public Sub GetWeekNumberInMonth(ticks As Long) As Int
	Dim dt As AHDateTime
	dt.Initialize : dt.Pattern = "W"
	Return dt.format(ticks)    
End Sub



'Returns True if the string can be converted to a b4a Date
'sDate - String of the date you want to check "01/24/2012"
Public Sub IsValidDate(sDate As String) As Boolean
    Try
        DateTime.DateParse(sDate)
        Return True
    Catch
        Return False
    End Try
End Sub


'Returns the last day of  the month of the passed in date
'dDate - A valid b4a date
Public Sub LDateOfMonth(dDate As Long) As Long
	Dim nDay As Int
	nDay = GetLastDay(dDate)
	Return  DateTime.DateParse(DateTime.GetMonth(dDate) & "/" &  DateTime.GetDayOfMonth(dDate) & "/" & DateTime.GetYear(dDate))
End Sub

'Returns true if the 2 passed in dates are of the same month and year
'D1 - first date (b4a date) to compare
'D2 - second date (b4a date)  to compare
Public Sub SameMonth(D1 As Long, D2 As Long) As Boolean
     If (DateTime.GetMonth(D1) = DateTime.GetMonth(D2)) AND (DateTime.GetYear(D1) = DateTime.GetYear(D2)) Then
        Return True
     End If
	 Return False
End Sub


'Returns an INT of the last day of the month of the passed in date 
'dtDate - the date to find the last day of the month
Public  Sub GetLastDay(dtDate As Long) As Int
	Dim nMonth          As String
	Dim nYear           As Long
	Dim nDay            As Int
	Dim nResult         As Long

	nMonth = DateTime.GetMonth(dtDate)
	nYear = DateTime.GetYear(dtDate)
	 
	For nDay = 31 To 27 Step -1
		If IsValidDate((nMonth) & "/" & CStr(nDay) & "/" & CStr(nYear)) Then
	         Return  nDay
	     End If
	Next
 	Return -1

End Sub

'Returns a b4a date that is the first day of the month
'dDate - A valid b4a date to that will be  the first of the month
Public Sub FDateOfMonth( dDate As Long) As Long
	Return  DateTime.DateParse(CStr(DateTime.GetMonth(dDate)) & "/01/" & CStr(DateTime.GetYear(dDate)) )
End Sub

'Returns a b4a date that is the is of the past in day
'dDate - A valid b4a date 
'sDay - a string of the day
'Returns a b4a long date 
Public Sub DayDateOfMonth( dDate As Long,sDay As String) As Long
	Return  DateTime.DateParse(CStr(DateTime.GetMonth(dDate)) & "/" & sDay & "/" & CStr(DateTime.GetYear(dDate)) )
End Sub

'Returns a string contaning the first of the month 
'dtDate - the date to find the first day (b4a)
Public Sub Date2Str(dtDate As Long) As String
	Return DateTime.GetMonth(dtDate) & "/" & DateTime.GetDayOfMonth(dtDate) & "/" & DateTime.GetYear(dtDate)
End Sub

#End Region



#Region Misc Function
'Just like VB (converts a object (if it can) to a string
Private Sub CStr(I As Object) As String
	Try
  		Return "" & I
	Catch 
		Return ""
	End Try
End Sub
'Just like VB 
Sub iif(boolCondition As Object, returnTrue As Object, returnFalse As Object) As Object
	If boolCondition Then
		Return returnTrue
	Else
		Return returnFalse
	End If
End Sub 

Public Sub Str2Int(s As String) As Int
	Return s
End Sub

#End Region



'Sub T1_Ended(endedOK As Boolean, error As String) 'The thread has terminated. If endedOK is False error holds the reason for failure
'	Log("Thread ended: " & endedOK & " " & error)
'	If  (endedOK = False) Then
'		Dim e As ExceptionEx
'		e = T1.Exception
'		Log(e.StackTrace)
'	End If
'	
'	'If endedOK Then CallSub(Main, "NewDataReceived")
'End Sub
